from flask import Flask, render_template
from model.memory import load_dreams
from model.tokenizer import Tokenizer
from context.context import load_context
import threading


app = Flask(__name__)
tokenizer = Tokenizer()


@app.route("/")
def index():
    dreams = load_dreams()
    top_dreams = dreams[:5]
    memory_size = len(load_context())
    return render_template("index.html",
                           vocab_size=len(tokenizer.vocab),
                           top_dreams=top_dreams,
                           memory_size=memory_size)


def run_dashboard():
    app.run(host="0.0.0.0", port=5000, debug=False, use_reloader=False)
